xfs
[Top] [All Lists]

[PATCH] xfstests: 297: simple sparse copy testcase for btrfs

To: xfs@xxxxxxxxxxx
Subject: [PATCH] xfstests: 297: simple sparse copy testcase for btrfs
From: Koen De Wit <koen.de.wit@xxxxxxxxxx>
Date: Fri, 18 Jan 2013 22:48:03 +0100
Delivered-to: xfs@xxxxxxxxxxx
User-agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.1.16) Gecko/20111110 Icedove/3.0.11
Signed-off-by: Koen De Wit <koen.de.wit@xxxxxxxxxx>
---
297 | 75 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 297.out |   10 ++++++++
 2 files changed, 85 insertions(+), 0 deletions(-)
 create mode 100644 297
 create mode 100644 297.out

diff --git a/297 b/297
new file mode 100644
index 0000000..0851b57
--- /dev/null
+++ b/297
@@ -0,0 +1,75 @@
+#! /bin/bash
+# FS QA Test No. 297
+#
+# Tests file clone functionality of btrfs ("reflinks"):
+#   - Reflink a file
+#   - Reflink the reflinked file
+#   - Modify the original file
+#   - Modify the reflinked file
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2013, Oracle and/or its affiliates.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+# creator
+owner=koen.de.wit@xxxxxxxxxx
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+_supported_fs btrfs
+_supported_os Linux
+
+_require_cp_reflink
+
+TESTDIR1=$TEST_DIR/test-$seq.$$
+mkdir $TESTDIR1
+
+_catfiles() {
+    for F in original copy1 copy2
+    do
+        md5sum $TESTDIR1/$F | $AWK_PROG 'END {print $1}'
+    done
+}
+
+$XFS_IO_PROG -f -c 'pwrite -S 0x61 0 9000' $TESTDIR1/original > /dev/null
+cp --reflink $TESTDIR1/original $TESTDIR1/copy1
+cp --reflink $TESTDIR1/copy1 $TESTDIR1/copy2
+_catfiles
+$XFS_IO_PROG -c 'pwrite -S 0x62 0 9000' $TESTDIR1/original > /dev/null
+_catfiles
+$XFS_IO_PROG -c 'pwrite -S 0x63 0 9000' $TESTDIR1/copy1 > /dev/null
+_catfiles
+
+# success, all done
+status=0
+exit
diff --git a/297.out b/297.out
new file mode 100644
index 0000000..39c498b
--- /dev/null
+++ b/297.out
@@ -0,0 +1,10 @@
+QA output created by 297
+42d69d1a6d333a7ebdf64792a555e392
+42d69d1a6d333a7ebdf64792a555e392
+42d69d1a6d333a7ebdf64792a555e392
+4a847a25439532bf48b68c9e9536ed5b
+42d69d1a6d333a7ebdf64792a555e392
+42d69d1a6d333a7ebdf64792a555e392
+4a847a25439532bf48b68c9e9536ed5b
+e271cd47d9f62ebc96cb4e67ae4d16db
+42d69d1a6d333a7ebdf64792a555e392
--
1.7.2.5

<Prev in Thread] Current Thread [Next in Thread>
  • [PATCH] xfstests: 297: simple sparse copy testcase for btrfs, Koen De Wit <=